theory FutureIdeas = PCL:

(* method for fixing up the AA1S/AA1R/etc mess 
   not sure if it's worth it since the other S/R/etc axioms have to stay
*)

syntax
	CA	::	"[thread, action] => Formula"
translations
	"CA(X,(send t))" == "Send(X,t)"

axioms

	A1:	"MF(P, [a], X, CA(X,a))"

lemma "MF(P, [send ((k::key) ## [])], X, Send(X,k ## []))"
apply (rule A1);
done;

(* Maybe a better way to fix P1SS/etc, but it doesn't work yet. *)

constdefs

	AFPred	:: "ActionFormula => bool"
		"AFPred a == True";
(*
syntax
	TT	::	"ActionFormula => bool" ("TT'(_')" 70)
translations
	"TT(Send(X,t))" == "True";
*)



axioms

	P1Test:	"[| AFPred(a) |] ==> MF(P, S, X, TrueProp(ActionFormula(a)))";

lemma "MF(P,S, X, Send(X,t))";
apply (rule P1Test);
apply (simp add: P1Test);