theory PCLTerm = Main:

global

(* types that can be PCL terms *)
typedecl name
typedecl "term"
typedecl key
typedecl nonce
typedecl thread

typedecl cterm


typedecl termlist

(*
nonterminals

termlist
*)
(*
datatype termlist = Name name
	| PTerm "term"
	| Nil
*)

(* Now let's prove that the above types satisfy the axioms of PCLTerm,
 of which there are none.  *)

axclass PCLTerm < type

instance name::PCLTerm
by intro_classes

instance "term"::PCLTerm
by intro_classes

instance key::PCLTerm
by intro_classes

instance nonce::PCLTerm
by intro_classes

instance thread::PCLTerm
by intro_classes


instance termlist ::PCLTerm
by intro_classes


(*
consts

	TermUnit	::	"'a::PCLTerm => termlist"	("_" 70)
	TermPair	::	"[termlist, termlist] => termlist" ("_ , _" [70,65] 65)
	TermProp	::	"'a::PCLTerm => bool"	 ("B: _")
*)
end