theory Proof = PCL:;


axioms
(*
HON[dest]: "[|	MF(Start(<X,xs>), [noop], <X,xs>, P) ;
				MF(P, [noop], <X,xs>, P) ;
				MF(P, [new [[x::nonce]], send [[X::name, Y::name, x]]], <X,xs>, P) ;
				MF(P, [receive [[X,Y,y,z]], match [[z]] / SIG{key(Y)}([[X,x,y]])], <X,xs>, P) |]
			==> (Honest(X) --> P)"

*)
 HON[dest]: "[|	MF(Start(<X,xs>), [noop], <X,xs>, P) ;
				MF(P, [noop], <X,xs>, P) ;
				MF(P, [new [[x::nonce]], send [[X::name, Y::name, x]]], <X,xs>, P) ;
				MF(P, [receive [[X,Y,y,z]], match [[z]] / SIG{key(Y)}([[X,x,y]])], <X,xs>, P);
				MF(P, [receive [[X,Y,y]], new [[x]], send [[X,Y,x,SIG{key(X)}([[Y,x,y]])]] ], <X,xs>, P) |]
			==> (Honest(X) --> P)";



lemma AA5: "MF(~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[(Y::name),(x::nonce),(y::nonce)]])]],m)),
			[new [[x]], send [[X, Y, x]]], <X,s>,
			~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)))"
			by (rule SEQ, rule AA5N, rule AA5S, simp);
		

lemma HON1: "Honest(X) --> ((Send(<X,s>,m) & Contains([[SIG{key(X)}([[(Y::name),(x::nonce),(y::nonce)]])]],m))
			-->	(Receive(<X,s>,[[X,Y,y]]) << Send(<X,s>,[[X,Y,x,SIG{key(X)}([[Y,x,y]])]]) ))";
	apply (rule HON);
	apply (rule G3, rule AA2S, blast+);
	defer 1;
	apply (frule G3);
	apply (rule AA5);
	apply (clarify del: ContainsPred_def);
	prefer 2;
	apply (clarify del: ContainsPred_def);
	apply (auto);
	back;

	apply (safe);
	apply (auto 1);
	apply (rule SEQ);


	proof -;
	have a: "MF(Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]),
			[new [[x]], send [[X, Y, x]]], <X,s>,
			 Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]))" 
			by ( rule P1RS);
	have b: "MF(~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)),
			[new [[x]], send [[X, Y, x]]], <X,s>,
			~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)))";
			by (rule SEQ, rule AA5N, rule AA5S, auto);
	have c: "~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)) --> ~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m))"; by blast;
	have d: "Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]) --> Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]])" by blast;
	have e: "~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)) & Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]) --> ~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m))" by blast;
	have f: "~(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)) & Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]) --> Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]])" by blast;
	from 
	
			

	moreover have 
	apply (rule G4);
	apply (rule classical);
	apply (rule AA5No);	
	apply (rule impI);
	apply (rule mp);a

 
	apply (rule G3, rule P1RS, blast+)+;
	done;




, rule P1RS [where ta="[[X::name,Y::name,y::nonce]]" and tb="[[X,Y,x::nonce,SIG{key(X)}([[Y,x,y]])]]"]);
	apply (auto);


	apply (rule G3);
	apply (rule AA2S);
	apply (blast+);

	proof -
	have "MF(Start(<X,s>), [noop], <X,s>, ~Send(<X,s>, m))" by (rule AA2S);
	thus "MF(Start(<X,s>),[noop], <X,s>, Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m)
			--> Receive(<X,s>,[[X,Y,y]]) << Send(<X,s>,[[X,Y,x,SIG{key(X)}([[Y,x,y]])]]) )";
		apply (rule G3);
		by blast+;
	next;
	defer 1;
	have "MF(Receive(<X,s>,[[X,Y,y]]) << Send(<X,s>,[[X,Y,x,SIG{key(X)}([[Y,x,y]])]]),
			[receive [[X,Y,y,z]], match [[z]] / SIG{key(Y)}([[X,x,y]])], <X,s>,
			Receive(<X,s>,[[X,Y,y]]) << Send(<X,s>,[[X,Y,x,SIG{key(X)}([[Y,x,y]])]]))"; by (rule P1RS);
	thus "MF(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y, x, y]])]],m) -->
       			Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]),
			[receive [[X, Y, y, z]], match [[z]] / SIG{key(X)}([[X, x, y]])],  <X,s>,
			Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y, x, y]])]],m) -->
            	Receive(<X,s>,[[X, Y, y]]) << Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y, x, y]])]]))";


	have "MF(Receive(<X,s>,[[X,Y,y]]) << Send(<X,s>,[[X,Y,x,SIG{key(X)}([[Y,x,y]])]]),
			[new [[x]], send [[X,Y,x]]], <X,s>,
			Receive(<X,s>,[[X,Y,y]]) << Send(<X,s>,[[X,Y,x,SIG{key(X)}([[Y,x,y]])]]))" by (rule P1RS);
	thus "MF(Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m) -->
       			Receive(<X,s>,[[X, Y, y]]) <<
       			Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y,x,y]])]]),
			[new [[x]], send [[X,Y,y]]],<X,s>,
			Send(<X,s>,m) & Contains([[SIG{key(X)}([[Y,x,y]])]],m) -->
      				Receive(<X,s>,[[X, Y, y]]) <<
      				Send(<X,s>,[[X, Y, x, SIG{key(X)}([[Y,x,y]])]]))";



(*				
	MF(P, [receive [[X, Y, y::nonce, z::term]], match [[z]] / SIG {key(X)}([[y,x,Y]])], <Y,xs>, P)  |]		
			
*)


(*		MF(P, [receive [[Y,X,x]], new [[y]], send [[X,Y,y,SIG{key(X)}([[y,x,Y]])]] ], <X,sy>, P) |] *)
(*
lemma IMPAND: "[|A --> B --> C|] ==> A & B --> C";
by (blast);
*)


lemma HON1: "Honest(X) --> Send(<X,s>,m) & Contains([[SIG{key(X)}([[(y::nonce),(x::nonce),(Y::name)]])]],m)
			-->	(Receive(<X,s>,[[Y,X,x]]) << Send(<X,s>,[[X,Y,y,SIG{key(X)}([[y,x,Y]])]]))";
	apply (rule HON); 
	apply (rule G3);
	apply (rule AA2S);
	apply (blast+);

	apply (rule G3 [where Pa="Send(<X,s>,m) & Contains([[SIG{key(X)}([[y, x, Y]])]],m)"]);


	apply (rule G2);
	apply (rule P1S);
	defer 1;
	apply (rule impI);
	apply (blast);
	apply (rule mp);
	apply (simp);

	apply (rule G3);
	apply (rule P1RS [where ta="[[Y, X, x]]" and tb="[[X, Y, y, SIG{key(X)}([[y, x, Y]])]]"]);
	apply (clarify);
	apply (auto);
	apply (blast);
	apply (blast);



	apply (rule G4);
	apply (rule P1RS);
	apply (blast);

	proof -;
	next;
	have "MF(Receive(<X,s>,[[x,Y,X]]) << Send(<X,s>, [[X,Y,y,SIG{key(X)}([[y,x,Y]])]] ), [new [[y]], send [[X,Y,y]]], <X,s>, Receive(<X,s>,[[x,Y,X]]) << Send(<X,s>, [[X,Y,y,SIG{key(X)}([[y,x,Y]])]] ))" by (rule P1RS);
	then show "MF(Send(<X,s>,m) & Contains([[SIG{key(X)}([[y, x, Y]])]],m) --> 
					Receive(<X,s>,[[Y, X, x]]) << Send(<X,s>,[[X, Y, y, SIG{key(X)}([[y, x, Y]])]]),
			 	[noop],<X,s>,
				Send(<X,s>,m) & Contains([[SIG{key(X)}([[y, x, Y]])]],m) -->
                    Receive(<X,s>,[[Y, X, x]]) << Send(<X,s>,[[X, Y, y, SIG{key(X)}([[y, x, Y]])]]))";
	apply (rule G3);
	thus "

"MF(Receive(<X,s>,[[x, Y, X]]) << Send(<X,s>,[[X, Y, y, SIG{key(X)}([[y, x, Y]])]]),
			 [new [[y]], send [[X, Y, y]]],
			 <X,s>,
			Receive(<X,s>,[[x, Y, X]]) << Send(<X,s>,[[X, Y, y, SIG{key(X)}([[y, x, Y]])]]))";
	

	apply (rule G3);
	apply (rule P1RS);
	apply (simp);
	apply (auto);
	proof -
	have "MF(Start(<X,s>), [noop], <X,s>, ~Send(<X,s>,m))" by (rule AA2S);
	thus "MF(Start(<X,s>)


lemma HON1: "Honest(X) --> Send(<X,s>,m) & Contains([[SIG{key(X)}([[(y::nonce),(x::nonce),(Y::name)]])]],m)
			-->	(Receive(<X,s>,[[Y,X,x]]) << Send(<X,s>,[[X,Y,y,SIG{key(X)}([[y,x,Y]])]]))"
	apply (rule HON); 
	apply (rule G3);
	apply (rule AA2S);
	apply (blast+);
	apply (auto);
	proof -
	have "MF(Start(<X,s>), [noop], <X,s>, ~Send(<X,s>,m))" by (rule AA2S);
	thus "MF(Start(<X,s>)


lemma "MF(P, [new [[x::nonce]], 
			  send [[Y::name, X::name, x]], 
			  receive [[X, Y, y::nonce, z::nonce]],
			  match [[z]] / SIG{key(X)}([[y,x,Y]])],
		 <Y,sx>, 
		  Honest(X) & (Y ~= X) --> 
			(EY sy.
				Send(<Y,xs>,[[Y,X,x]]) << Receive(<X,sy>,[[Y,X,x]])
				& Receive(<X,sy>,[[Y,X,x]]) << Send(<X,sy>,[[X,Y,y,SIG{key(X)}([[y,x,Y]])]])
				& Send(<X,sy>,[[X,Y,y,SIG{key(X)}([[y,x,Y]])]]) << Receive(<Y,xs>,[[Y,X,Y,y,SIG{key(X)}([[y,x,Y]])]])))"
proof -
	have "MF(P, [ match [[z]] / SIG{key(X)}([[y,x,Y]])], <Y,xs>, Verify(<Y,xs>, [[SIG{key(X)}([[y,x,Y]])]]))";
		by (rule AA1V);
	have 
	


lemma "MF(P, [new [[x::nonce]], 
			  send [[Y::name, X::name, x]], 
			  receive [[X, Y, y::nonce, z::nonce]],
			  match [[z]] / SIG {key(X)}([[y,x,Y]])],
		 <Y,sx>, 
		  Honest(X) & (Y ~= X) --> 
			(EY sy.
				Send(<Y,xs>,[[Y,X,x]]) << Receive(<X,sy>,[[Y,X,x]])
				& Receive(<X,sy>,[[Y,X,x]]) << Send(<X,sy>,[[X,Y,y,SIG{key(X)}([[y,x,Y]])]])
				& Send(<X,sy>,[[X,Y,y,SIG{key(X)}([[y,x,Y]])]]) << Receive(<Y,xs>,[[Y,X,Y,y,SIG{key(X)}([[y,x,Y]])]])))"
proof -
	have "MF(P, [ match [[z]] / SIG{key(X)}([[y,x,Y]])], <Y,xs>, Verify(<Y,xs>, [[SIG{key(X)}([[y,x,Y]])]]))";
		by (rule AA1V);
	have 
	

