theory TermListTest = TermList:;

ML "set show_types"


(* Test Contains *)


lemma "Contains(((t::name) ## []), ((t::name) ## (k::key) ## []))";
by (simp);

lemma "(b::nonce) IN (Name a # Nonce b # [])";
apply (simp)
done

lemma "(a::name) IN (Name (a) # [])";
by simp

lemma "(X::name) IN (Name X # Nonce n # Term t1 # Term t2 # Key k # Thread Y # [])"
by simp

lemma "(n::nonce) IN (Name X # Nonce n # Term t1 # Term t2 # Key k # Thread Y # [])"
by simp

lemma "(t1::term) IN (Name X # Nonce n # Term t1 # Term t2 # Key k # Thread Y # [])"
by simp

lemma "t2 = t --> (t::term) IN (Name X # Nonce n # Term t1 # Term t2 # Key k # Thread Y # [])";
apply simp
done

lemma "(k::key) IN (Name X # Nonce n # Term t1 # Term t2 # Key k # Thread Y # [])"
by simp

lemma "(Y::thread) IN (Name X # Nonce n # Term t1 # Term t2 # Key k # Thread Y # [])";
by simp


(* 
 * Test List Syntax 
 *)	

lemma "(n::nonce) IN ((t::name) ## (n::nonce) ## [])";
apply (simp)
done;

lemma "(t::term) IN (k::key) ## (n::nonce) ## n ## k ## (X::name) ## k ## k ## (Y::thread) ## t ## []"
by (simp);

lemma "(n::nonce) IN [[k::key,n::nonce]]";
by (simp);

end