header {* Basic theory for Subsets*}

theory BasicSubset = PCL:

global

axioms

  ID:    "Contains(A, A) " 
  TRAN:    "[| Contains(B, A); Contains(C,B) |] ==> Contains(C,A)"
  S1:    "Contains(C,B) ==>  Contains((A,C), (A, B))"
  S2:      "Contains((A, B), A)"

(* FINISH TRANSLATING
  S3      "A << B,A"
  S4      "A << B ==> A << C, B"

  (*star operations*)

  ROT    "A << B, C * D ==> A << D, B * C"
  SWAP   "A << B, C * D ==> A << D, C * B" 

  IS   "A << C * B ==> A << C, B"
  RS   "A << C, B ==> A << C * B"

  MSR  "A << B, C * D ==> A << B * C , D"
  MSL  "A << B * C, D ==> A << B, C*D" 

  FLIP "A << B * C ==> A << C * B"
*)

end

(*OLD VERSION:: NEEDS TO BE INTEGRATED SOMEHOW!!*)
(*
types

  set
  (*elem*)

arities
  set: CTerm

nonterminals

  setlist
  setI

consts 
  

  Subset :: [set, set] => o 
  Setlist :: [set, set] => set
  Setsplit ::  [set, set] => set 

syntax

  "Setlist" :: [idt, setlist] => setlist ("_,_" [60, 40] 40)
  "Setlist" :: [idt, idt] => setlist ("_,_" [60, 40] 40)
  ""       :: idt => setI ("_")
  ""       :: setlist => setI ("_")
  "Subset" :: [setI, setI] => o ("_ << _")
  (*"Parens"  :: setlist => setlist ("'(_')" [80] 60)*)
  "Setsplit":: [setI, setI] => setI (" _ * _ " 0)

  (*C      :: elem => set ("{_}")*)
  (*Element :: idt => elem  ("_")*)
  (*Member :: [elem, set] => o (" _ MEM _")*)


(*
  Termlist :: [set, set] => set
  TermUnit :: term  => term  
  Subset  :: [term, term] => o 
*)



(*
syntax

  "Member" :: [elem, set] => o  (" _ MEM _ ")
  "Subset" :: [set, set] => o (" _ << _")
  

"Termlist" :: [idt, elem] => termlist ("_ , _")
  "TermUnit" :: idt => termlist ("_")
  "Subset"  :: [termlist, termlist] => o   (" _ << _ ") 
*)  


rules

  (*SUBS    "x MEM A --> x MEM B ==> A << B"*)


  (*rules for sets*)
  
  ID    "A << A"
  TRAN    "[| A << B; B << C |] ==> A << C"
  S1    "B << C ==>  A,B << A,C"
  S2      "A << A,B"
  S3      "A << B,A"
  S4      "A << B ==> A << C, B"

  (*star operations*)

  ROT    "A << B, C * D ==> A << D, B * C"
  SWAP   "A << B, C * D ==> A << D, C * B" 

  IS   "A << C * B ==> A << C, B"
  RS   "A << C, B ==> A << C * B"

  MSR  "A << B, C * D ==> A << B * C , D"
  MSL  "A << B * C, D ==> A << B, C*D" 

  FLIP "A << B * C ==> A << C * B"

  

end	
*)
