ML "add_path\"~/pcl\"";
ML "set show_types"
ML "set show_sorts"

theory proof_CR1 = NewCord:;

lemma HON1: "Honest(Y) -->  ((Send(<Y,s>, m) & Contains(m, SIG[key(Y)](y,x,na(X)))) --> (Receive(<Y,s>,na(X),na(Y),x) < Send(<Y,s>, na(Y),na(X),y,SIG[key(Y)](y,x,na(X)))))";
apply (rule HON);
proof -;
  have a: "{Start(<Y,s>), <Y,s>[noop], ~Send(<Y,s>, m)}" by (rule AA2S);
  then show ONE: "{Start(<Y,s>),<Y,s>[noop],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}"; 
    apply (rule G3);
    apply blast;
    apply blast;
    done;
  next have b: "{Receive(<Y,s>,na(X),na(Y),x) < Send(<Y,s>, na(Y),na(X),y,SIG[key(Y)](y,x,na(X))), <Y,s>[new y; send na(Y), na(X), y], Receive(<Y,s>,na(X),na(Y),x) < Send(<Y,s>, na(Y),na(X),y,SIG[key(Y)](y,x,na(X)))}" by (rule P1P);
    then show TWO: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) -->
     Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[new y;send na(Y) , na(X) , y],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}";
      apply (rule G3);
      apply blast;
      apply blast;
      done;
    next;
      have c: "{Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x , z;match z / SIG[key(X)](x , y , na(Y))], Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule P1P);   
      then show THREE: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x , z;match z / SIG[key(X)](x , y , na(Y))],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}"; 
	apply (rule G3);
	apply blast;
	apply blast;
	done;
      next;
	have d: "{Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))], Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule P1P);
	then show FOUR: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}";
	  apply (rule G3);
	  apply blast;
	  apply blast;
	  done;
	qed;

lemma HON2: "Honest(Y) --> (Send(<Y,s>, na(Y), na(X), y, SIG[key(Y)](y,x,na(X))) --> FirstSend(<Y,s>, y, na(Y), na(X), y, SIG[key(Y)](y,x,na(X))))";
apply (rule HON);
proof -;
  have a: "{Start(<Y,s>),<Y,s>[noop],~Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule AA2S);
  then show ONE: "{Start(<Y,s>),<Y,s>[noop],Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}";
    apply (rule G3);
    apply blast;
    apply blast;
    done;
  next;
    have b: "{FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))), <Y,s>[new y; send na(Y), na(X), y], FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule P1F);
    then show TWO: "{Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x, na(X))),<Y,s>[new y;send na(Y) , na(X) , y],Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}";
      apply (rule G3);
      apply blast;
      apply blast;
      done;
    next;
      have c: "{FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x , z;match z / SIG[key(X)](x , y , na(Y))], FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule P1F);
      then show THREE: "{Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x , z;match z / SIG[key(X)](x , y , na(Y))],Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}";
	apply (rule G3);
	apply blast;
	apply blast;
	done;
      next;
	have d: "{FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))), <Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))], FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule P1F);
	then show FOUR: "{Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))],Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))) --> FirstSend(<Y,s>,y , na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}";
	  apply (rule G3);
	  apply blast;
	  apply blast;
	  done;
	qed;

theorem CR1: "{P, <X,s1>[new x; send na(X),na(Y),x; receive na(Y),na(X),y,z; match z/SIG[key(Y)](y,x,na(X))], (Honest(Y) & Y ~= X) --> (EX s2. (Send(<X,s1>,na(X),na(Y),x) < Receive(<Y, s2>, na(X), na(Y), x)) & (Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x,na(X)))) & (Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y, x, na(X))) < Receive(<X,s1>, na(Y), na(X), y, SIG[key(Y)](y, x, na(X)))))}";

proof -;
  have ONE: "{P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))], Verify(<X,s1>, SIG[key(Y)](y,x,na(X)))}" by (rule AA1V);
  have VERi: "(Honest(Y) & Verify(<X, s1>, SIG[key(Y)](y, x, na(X))) & Y ~= X) --> (EX s2 u.(Send(<Y,s2>, u) & Contains(u, SIG[key(Y)](y, x, na(X)))))" by (rule VER);
  from VERi have i1: "Verify(<X, s1>, SIG[key(Y)](y, x, na(X))) --> (Honest(Y) & Y ~=X --> (EX s2 u.(Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X))))))" by blast;
  have TAUT: "P --> P" by blast;
  from ONE TAUT i1 have TWO: "{P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))], Honest(Y) & Y ~=X --> (EX s2 u.(Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X)))))}" by (rule G3);
  have THREE: "Honest(Y) --> (Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X))))" by (rule HON1);
  from THREE have aa: "{P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))], Honest(Y) --> (Send(<Y,s2>, u) & Contains(u, SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X))))}" by (rule G4);
  have i2: "(Honest(Y) --> (Send(<Y,s2>, u) & Contains(u, SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X))))) --> (Honest(Y) & Send(<Y,s2>, u) & Contains(u, SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X))))" by blast;
  from aa TAUT i2 have ab: "{P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))],Honest(Y) & Send(<Y,s2>, u) & Contains(u, SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X)))}" by (rule G3);

  have TEST5: "(A & (A--> B)) --> B" by blast;

  have TEST45: "((EX a. A) & ((EX a. A) --> B)) --> B" by blast;

  have TEST4: "((EX a. Send(a,b)) & (EX a.(Send(a,b)) --> P)) --> P"; by blast;

  have TEST3: "(ALL w z.((Q -->(EX a. Send(a,b))) & (Send(w,z) --> B)) --> (Q --> (EX a. B)))" by blast;

(*
  have TEST2: "((A --> (EX p. Send(r,p))) & (Send(r,p) --> Receive(r,p))) --> (A --> (EX p. Receive(r,p)))"; by simp;

  have TEST: "((A --> (EX v u. Send(v, u))) & (A & Send(v, u) --> Receive(b, u))) --> (A --> (EX v u. Receive(b, u)))" by blast;
 *) 


  have i2: "((Honest(Y) & Y ~=X --> (EX s2 u.(Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X)))))) & (Honest(Y) & Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X))))) --> (Honest(Y) & (Y ~= X) --> (EX s2 u. Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X)))))";
    proof;
      assume a: "((Honest(Y) & Y ~=X --> (EX s2 u.(Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X)))))) & (Honest(Y) & Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X)))))";
      assume b: "Honest(Y) & Y ~= X";
      from a b have c: "(EX s2 u.(Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X))))) & (Honest(Y) & Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, na(X), na(Y), x) < Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y,x, na(X))))" by blast;
      then show d: "

  




(*OLD PROOF OF 4
      have c: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) -->  Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop], Inorder(<Y,s>: receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop)}" by (rule AA4);
      have d:  "(Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) -->  Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))) --> (Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) -->  Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))))" by blast;
      have e: "Inorder(<Y,s>: receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop) -->  Inorder(<Y,s>: new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop) & (Receive(<Y,s>,  na(X) , na(Y) , x) <# <Y,s>: new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop)" by (rule AA4R);
      have f: "(Receive(<Y,s>,  na(X) , na(Y) , x) <# <Y,s>: new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop) --> (Receive(<Y,s>,  na(X) , na(Y) , x) <# <Y,s>: send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop)" by (rule ORDPUSH);
      have g: "(Receive(<Y,s>,  na(X) , na(Y) , x) <# <Y,s>: send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop) --> (Receive(<Y,s>, na(X), na(Y), x) < Send(<Y,s>, na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))))" by (rule ORDS);
      from e f g have h: "Inorder(<Y,s>: receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop) --> (Receive(<Y,s>, na(X), na(Y), x) < Send(<Y,s>, na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))))" by blast;
      from c d h have i:  "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) -->  Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop], (Receive(<Y,s>, na(X), na(Y), x) < Send(<Y,s>, na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))))}" by (rule G3);
      have j: "(Receive(<Y,s>, na(X), na(Y), x) < Send(<Y,s>, na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))) --> Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))" by blast;
      from i d j have k: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x;new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule G3);
      from k have l: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x * new y;send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule RemoveStar);
      from l have m: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X))),<Y,s>[receive na(X) , na(Y) , x ; new y * send na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)); noop],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,na(X) , na(Y) , x) < Send(<Y,s>,na(Y) , na(X) , y , SIG[key(Y)](y , x , na(X)))}" by (rule MSL);

MORE TO DO HERE!

*)
