theory PCLTerm = Main:

global

(* types that can be PCL terms *)
typedecl name
typedecl "term"
typedecl key
typedecl nonce
(* typedecl thread *)

(* other types *)
typedecl sid
typedecl cord
nonterminals
	ActionFormula
(* 	thread *)
	Formula
(*	strand  *)

datatype thread = 
	 ThreadPair name sid ("<_,_>")

(* typedecl ActionFormula  *)

(* Now let's prove that the above types satisfy the axioms of PCLTerm,
 of which there are none.  *)

axclass PCLTerm < type

instance name::PCLTerm
by intro_classes

instance "term"::PCLTerm
by intro_classes

instance key::PCLTerm
by intro_classes

instance nonce::PCLTerm
by intro_classes

instance thread::PCLTerm
by intro_classes

syntax
	TrueFormula			::	"Formula => bool"						("_")

end