theory PCLd = TermList:

global

(* a lot of types are now in PCLTerm *)
(* other types *)

typedecl sid
typedecl strand
typedecl cord

typedecl tlist

nonterminals
	ptermI


consts

	(* Threads are either variable or a <name, sid> pair *)
	Thread				::	"[name, sid] => thread" 	("<_,_>")


(*  attempt at treating name/sid pairs as HOL pairs.  results in ambiguity
*	Thread				::	"name * sid => thread" 		("_")
*)
(*
*	PTermAO				::	"'a::PCLTerm => tlist"	("_")
*	PTermList			::	"tlist list => ptermI" ("_") 
*)


(*	a single term must be a list or else ptermI is ambiguous*)
	PTerm				::	"'a::PCLTerm => ptermI" ("_")

(*	PTermList			::	"termlist => ptermI"	("_")
*)
(* Action Formulas *)

	PSend		::	"[thread, termlist] => bool"	("Send'(_,_')")

(*
	PReceive	::	"[thread, ptermI] => bool"	("Receive'(_,_')")
	PNew		::	"[thread, ptermI] => bool"	("New'(_,_')")
	PDecrypt	::	"[thread, ptermI] => bool"	("Decrypt'(_,_')")
	PVerify		::	"[thread, ptermI] => bool"	("Verify'(_,_')")

*)
	



	PHas	::	"[thread, 'a::PCLTerm] => bool"	("Has'(_,_')")

axioms

	A1 	:	"Send(P,t)"


end