ML "set show_types"
ML "set show_sorts";

theory NewCordTest = NewCord:;

lemma "{~Send(X,t), X[send u, v, w, g, u], ~Send(X,t)}";
apply (rule AA3S);
oops;

lemma "{Fresh(X,t), X[receive t,r], Fresh(X,t)}";
apply (rule P2R);
done;

lemma "(x::thread) = x";
oops;
lemma "(Honest(X) & Verify(<Y, s1>, SIG[key(X)](t)) & X ~= Y) --> (EX s2 u.(Send(<X,s2>, u) & (u CON SIG[key(X)](t))))";
apply (rule VER);
done;

lemma "{P, X[new t], Has(Y,x) --> X = Y}";
apply (rule AN2);
done;

lemma "Honest(Y) & Decrypt(<X, s>, ENC[key(Y)](p)) --> X = Y";
apply (rule SEC);
done;

lemma "{A, X[B], C}";
apply (rule ADDNOOP);
apply (rule REMNOOP);
oops;

lemma "{A, X[send x], Send(X,x)}";
apply (rule AA1S);
done;

lemma "Receive(X,x,y,z) --> Has(X,x,y,z)";
apply (rule REC);
done;

lemma "Has(X,x) & Has(X,y,z) --> Has(X,x,y,z)";
apply (rule TUP);
done;

lemma "Honest(X)";
oops;

lemma "Send(X,key(x)) & Send(X,key(x),name(y),z,w) & Honest(y)";
oops;

lemma "{P, X[send name(x)], Send(X,name(x))}";
apply (rule AA1S);
done;

lemma "Send(X,ENC[key(N)](y,z))";
oops;

lemma "{Send(P,t) < Receive(X,t), X[new o], Send(P,t) < Receive(X,t)}";
apply (rule P1P);
done;

lemma "{A & B, C, D}";
apply (rule G2);
oops;

lemma "{P, X[send a; send b; send c; send d], Q}"; 
apply (rule InsertStar);
apply (rule MSR);
apply (rule MSR);
apply (rule RemoveStar);
apply (rule InsertStar);
apply (rule MSL);
apply (rule MSL);
apply (rule RemoveStar);
apply (rule OLDSEQ);
apply (rule MSR);
apply (rule MSR);
apply (rule MSL);
apply (rule MSL);
apply (rule MSR);
apply (rule SEQ);
prefer 2;
apply (rule InsertStar);
apply (rule SEQ);
apply (rule AA1S);
apply (rule MSL);
apply (rule MSL);



