ML "add_path\"~~/src/FOL\"";
ML "set show_types";

theory proof_071403 = Cord:;

lemma NINE: "{P, <X, sig1>(t)[new x; send X,Y,x; receive Y,X,y,z; match [z][SIG[Y](y,x,X)]], (Honest(Y) & ~Equal(X,Y)) --> Send(<X, sig1>, X, Y, x) < Receive(<Y, sig2>, X, Y, x)}";

apply (rule SEQ); ML "(*gives us 8 and general version of 7*)";
apply (rule AN3); ML "(*gives 7*)";
ML "(*use below to instantiate vars in rules*)";
apply (rule_tac Q = "FirstSend(<X, sig1>,x,X,Y,x) & ((Honest(Y) & ~Equal(X,Y)) --> Receive(<Y,sig2>, X, Y, x))" in G2);
prefer 2;
apply (blast);
apply (rule G1); ML "(*gives us 5 and 6-- proof of current subgoal 3 is below*)";
ML "(*proof of 6*)";
apply (rule_tac B = "FirstSend(<X,sig1>, x, X, Y, x)" in  SEQ);
apply (rule FS1);
apply (rule P1FS);
prefer 2;
proof; ML "(*proof of 7*)";
  assume "FirstSend(<X, sig1>,x,X,Y,x) & ((Honest(Y) & ~Equal(X,Y)) --> Receive(<Y,sig2>, X, Y, x))";
  from prems have a: "FirstSend(<X,sig1>,x , X , Y , x)" ..;
  from prems have b: "(Honest(Y) & ~ Equal(X,Y) --> Receive(<Y,sig2::idts>,X , Y , x))" ..;
  show "Honest(Y) & ~ Equal(X,Y) -->  Send(<X,sig1>,X , Y , x) < Receive(<Y,sig2>,X , Y , x)";
  proof;
    assume "Honest(Y) & ~Equal(X,Y)";
    from prems have c: "Receive(<Y,sig2::idts>,X , Y , x)"  by blast;
    have d: "(FirstSend(<X,sig1>,x , X , Y , x) & Receive(<Y,sig2::idts>,X , Y , x)) --> Send(<X,sig1>,X , Y , x) < Receive(<Y,sig2>,X , Y , x)" by (rule FS2R);
    from a c d show e: "Send(<X,sig1>,X , Y , x) < Receive(<Y,sig2>,X , Y , x)" by blast;
  qed;
next show "{Fresh(<X,sig1>,x), <X,sig1> ( t ) [ send X , Y , x;receive Y , X , y , z;match [z][SIG[Y](y , x , X)] ], Honest(Y) & ~ Equal(X,Y) -->  Receive(<Y,sig2>,X , Y , x)}";
proof -;
  apply_end (rule_tac B = "P | ~P" in SEQ);
  apply_end (rule G3);
  apply_end blast;
  apply_end (rule_tac B = "P | ~P" in SEQ);
  apply_end (rule G3);
  apply_end blast;
  apply_end (rule_tac Q = "Honest(Y) & ~Equal(X,Y) --> Receive(<Y,sig2>, X, Y, x) < Send(<Y,sig2>, Y, X, y, SIG[Y](y,x,X))" in  G2);
  prefer 2;
  apply_end blast; ML "(*gives us 4*)";
  prefer 2;
  apply_end (rule impI);
  assume "Honest(Y) & ~ Equal(X,Y) --> Receive(<Y,sig2>,X , Y , x) < Send(<Y,sig2>,Y , X , y , SIG[Y](y , x , X))";
  show "Honest(Y) & ~ Equal(X,Y) --> Receive(<Y,sig2>,X , Y , x)";
    proof;
      assume "Honest(Y) & ~Equal(X,Y)";
      from prems have aa: "Receive(<Y,sig2::idts>,X , Y , x::idts) < Send(<Y,sig2>,Y , X , y::idts , SIG[Y](y , x , X))" by blast;
      from aa show "Receive(<Y::idts,sig2::idts>,X::idts , Y , x::idts)" by (rule LESS1);
    qed;
  ML "(*now we have 4*)";
  apply_end (rule_tac Q = "Honest(Y) & ~Equal(X,Y) --> Send(<Y,sig2>, SIG[Y](y,x,X))" in G2);
  prefer 2;
  apply_end blast;
  prefer 2;
  apply_end (rule impI);
  next;
    assume "Honest(Y) & ~ Equal(X,Y) --> Send(<Y,sig2>, SIG[Y](y , x , X))";
    show "Honest(Y) & ~ Equal(X,Y) --> Receive(<Y,sig2>,X , Y , x) < Send(<Y,sig2>,Y , X , y , SIG[Y](y , x , X))";
    proof;
      assume "Honest(Y) & ~Equal(X,Y)";
      from prems have bb: "Send(<Y,sig2>, SIG[Y](y , x , X))" by blast;
      ML "(*proof uses fake rule for honesty here! technically anything i put would be true
	but if we knew the honesty rule it would be enough*)";
      show cc: "Receive(<Y,sig2>,X , Y , x) < Send(<Y,sig2>,Y , X , y , SIG[Y](y , x , X))" by (rule HON1);
    qed;
  ML "(*now we have 2*)";
  apply_end (rule_tac Q = "Verify(<X,sig1>, SIG[Y](y,x,X))" in G2);
  prefer 2;
  apply_end blast; ML "(*now we have 1 and part of 2*)";
  apply_end (rule AA1V); ML "(*now we get rid of 1 and just have part of 2*)";
  next;
    apply_end (rule impI);
    assume "Verify(<X,sig1>,SIG[Y](y , x , X))";
    show "Honest(Y) & ~ Equal(X,Y) --> Send(<Y,sig2>, SIG[Y](y , x , X))";
      proof;
	assume "Honest(Y) & ~Equal(X,Y)";
	from prems have dd: "(Honest(Y) & ~Equal(X,Y)) & Verify(<X,sig1>, SIG[Y](y,x,X))" by blast;
	have ee: "(Honest(Y) & ~Equal(X,Y)) & Verify(<X,sig1>, SIG[Y](y,x,X)) --> Send(<Y,sig2>, SIG[Y](y,x,X))" by (rule VER);
	from prems ee show ff: "Send(<Y,sig2>, SIG[Y](y,x,X))" by blast;
	qed;
      qed;
qed;

    

  
  


  
  



